dofile("..\\lib\\non_base.lua");
dofile("..\\lib\\non_util.lua");
dofile("..\\lib\\non_vdeo.lua");
dofile("..\\lib\\non_pain.lua");
dofile("..\\lib\\non_cont.lua");
dofile("..\\lib\\non_ctl.lua");
dofile("..\\lib\\non_bHea.lua");
dofile("..\\lib\\non_f030.lua");

dofile("..\\noncon\\multimed.lua");

dofile("..\\noncon\\ncfgame.lua");

-- ***************************************************
-- Constants
-- ***************************************************

NON_MAXIMUMPLAYERS=8;
NON_MINIMUMPLAYERS=1;

ncf_Stage_exit="exit";

-- **************************************************
-- Init Stage
-- **************************************************
function ncf_Stage_Init()
	local model={
		stagename="Init",
		screenwidth=320,
		screenheight=240,
		useKeyBoard=true,
		useTeamTaps=true,
		useJagPads=false,
		highscorefilenameparts={},
		beehead={
			useBeeHead=true,
			searchinfolders={"c:","d:","e:","f:","g:","h:","i:","j:","/user/local"},
			defaultplayershapewidth=20,
			defaultplayershapeheight=20,
		},
		nextstages={
			_default_={
				next=function() return ncf_Stage_Logo,NON_STAGE; end
			}
		}
	}
	
	local view={
	}

	return non_controllInit(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Logo Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Logo()
	local model={
		stagename="Logo",
		events={
			usePad=true,
			mastermode=false,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		nextstages={
			_default_={
				next=function() return ncf_Stage_Title,NON_STAGE; end,
			},
		},
	}

	local view={
		NonBox.new(0,0,320,240,0),
		NonText.new(50,130,nonFonts.redblue,"Logo@Screen",0)
	}
	
	return non_controllWaitForInput(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Title Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Title()
	local model={
		stagename="Title",
		events={
			usePad=true,
			mastermode=false,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		nextstages={
			_default_={
				next=function() return ncf_Stage_Credits,NON_STAGE; end,
			},
		},
	}

	local view={
		NonBox.new(0,0,320,240,0),
		NonText.new(50,130,nonFonts.redblue,"Title@Screen",0)
	}
	
	return non_controllWaitForInput(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Credits Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Credits()
	local model={
		stagename="Credits",
		events={
			usePad=true,
			mastermode=false,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		nextstages={
			Title={
				next=function() return ncf_Stage_GameInit,NON_STAGE; end,
			},
			Menu={
				next=function() return ncf_Stage_Menu,NON_STAGE; end,
			},
		},
	}

	local view={
		NonBox.new(0,0,320,240,0),
		NonText.new(50,130,nonFonts.redblue,"Credits@Screen",0)
	}
	
	return non_controllWaitForInput(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- GameInit Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_GameInit()
	local model={
		stagename="GameInit",
		nextstages={
			_default_={
				next=function() return ncf_Stage_Menu,NON_STAGE; end,
			},
		},
	}

	local view={
	}
	
	return non_controllGameInit(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Menu Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Menu()
	local view={
		viewgroups={
			menu={
				options={
					NonText.new(50,36,nonFonts.white,"TUTRIAL",0),
					NonText.new(50,63,nonFonts.white,"OPTIONS",0),
					NonText.new(50,90,nonFonts.white,"PLAYERS",0),
					NonText.new(50,117,nonFonts.white,"CREDITS",0),
					NonText.new(50,144,nonFonts.white,"START",0),
					NonText.new(50,171,nonFonts.white,"EXIT",0),
				},
			}
		},
		NonBox.new(0,0,320,240,0),
		"menu"
	}
	
	local model={
		stagename="Menu",
		events={
			usePad=false,
			mastermode=true,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		choices=6,
		choice=0,
		fonts={
			active=nonFonts.red,
			inactive=nonFonts.white
		},
		menupoint=1,
		nextstages={
			_default_={
				function() return ncf_Stage_Tutorial,NON_STAGE; end,
				function() return ncf_Stage_Options,NON_STAGE; end,
				function() return ncf_Stage_Players,NON_STAGE; end,
				function() return ncf_Stage_Credits,NON_STAGE; end,
				function() return ncf_Stage_GameRound,NON_STAGE; end,
				function() return "exit"; end,
			},
		},
		viewelements=view.viewgroups.menu
	}
	
	return non_controllMenu(view,model);
end

-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Options Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Options()
	local model={
		stagename="Options",
		events={
			usePad=true,
			mastermode=true,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		globalvalues={
			"nonNumberOfPlayers",
			"nonNumberOfRounds",
		},
		texts={
			"PLAYER",
			"ROUNDS",
		},
		pictures={
			nonShapes.icons.players,
			nonShapes.icons.rounds
		},
		min={1,1},
		max={8,99},
		checkpictures={
			nonShapes.icons.no,
			nonShapes.icons.yes
		},
		choices=2,
		choice=0,
		menupoint=1,
		fonts={
			active=nonFonts.red,
			inactive=nonFonts.white
		},
		nextstages={
			_default_={
				next=function() return ncf_Stage_Menu,NON_STAGE; end,
			},
		},
	}
	
	local view={
		viewgroups={
			background={
				NonBox.new(0,0,320,240,0),
			},
			options={
				NonText.new(60,36,nonFonts.red,"",0),
				NonText.new(60,63,nonFonts.white,"",0),
			},
			valuecomponents={
				NonText.new(256,36,nonFonts.white,"",0),
				NonText.new(256,63,nonFonts.white,"",0),
			},
			picturecomponents={
				NonPicture.new(20,36,36,25,0,nonShapes.icons.no),
				NonPicture.new(20,63,36,25,0,nonShapes.icons.yes),
			},
		},
		"background",
		"options",
		"valuecomponents",
		"picturecomponents"
	}
	
	return non_controllOption(view,model);
end

-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Players Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Players()
	local view={
		viewgroups={
			background={
				NonBox.new(0,0,320,240,0),
				NonText.new(100,10,nonFonts.redblue,"Players",0),
				NonText.new(91,92,nonFonts.redblue,"beeheads",0),
				NonText.new(20,200,nonFonts.small,"press pad key 1-8 to select players",0),
				NonText.new(56,210,nonFonts.small,"press pad button b to exit",0),
			},
			playersselect={
				numbers={
					[1]=NonText.new(46,36,nonFonts.small,"1",0),
					[2]=NonText.new(76,36,nonFonts.small,"2",0),
					[3]=NonText.new(106,36,nonFonts.small,"3",0),
					[4]=NonText.new(136,36,nonFonts.small,"4",0),
					[5]=NonText.new(166,36,nonFonts.small,"5",0),
					[6]=NonText.new(196,36,nonFonts.small,"6",0),
					[7]=NonText.new(226,36,nonFonts.small,"7",0),
					[8]=NonText.new(256,36,nonFonts.small,"8",0),
				},
				optionpictures={
					[1]=NonPicture.new(40,50,20,20,0,nonInternals.nonPlayerShapes[1]),
					[2]=NonPicture.new(70,50,20,20,0,nonInternals.nonPlayerShapes[2]),
					[3]=NonPicture.new(100,50,20,20,0,nonInternals.nonPlayerShapes[3]),
					[4]=NonPicture.new(130,50,20,20,0,nonInternals.nonPlayerShapes[4]),
					[5]=NonPicture.new(160,50,20,20,0,nonInternals.nonPlayerShapes[5]),
					[6]=NonPicture.new(190,50,20,20,0,nonInternals.nonPlayerShapes[6]),
					[7]=NonPicture.new(220,50,20,20,0,nonInternals.nonPlayerShapes[7]),
					[8]=NonPicture.new(250,50,20,20,0,nonInternals.nonPlayerShapes[8])
				},
				options={
					[1]=NonText.new(39,76,nonFonts.small,"123",0),
					[2]=NonText.new(69,76,nonFonts.small,"123",0),
					[3]=NonText.new(99,76,nonFonts.small,"123",0),
					[4]=NonText.new(129,76,nonFonts.small,"123",0),
					[5]=NonText.new(159,76,nonFonts.small,"123",0),
					[6]=NonText.new(189,76,nonFonts.small,"123",0),
					[7]=NonText.new(219,76,nonFonts.small,"123",0),
					[8]=NonText.new(249,76,nonFonts.small,"123",0)
				}
			},
			beeheadselect={
				optionpictures={
					NonPicture.new(16,118,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(116,118,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(216,118,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(16,144,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(116,144,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(216,144,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(16,170,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(116,170,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(216,170,20,20,0,nonInternals.nonPlayerShapes[1])
				},
				options={
					NonText.new(46,124,nonFonts.small,"12345678",0),
					NonText.new(146,124,nonFonts.small,"12345678",0),
					NonText.new(246,124,nonFonts.small,"12345678",0),
					NonText.new(46,150,nonFonts.small,"12345678",0),
					NonText.new(146,150,nonFonts.small,"12345678",0),
					NonText.new(246,150,nonFonts.small,"12345678",0),
					NonText.new(46,176,nonFonts.small,"12345678",0),
					NonText.new(146,176,nonFonts.small,"12345678",0),
					NonText.new(246,176,nonFonts.small,"12345678",0)
				},
			},
		},
		"background",
		"playersselect",
		"beeheadselect"		
	}

	local model={
		stagename="Players",
		globalvalues={
			topbeeheadplayerid="nonTopBeeHeadPlayerID"
		},
		events={
			usePad=true,
			mastermode=true,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		center=true,
		topplayerid=17,
		allplayerpics={nil,nil,nil,nil,nil,nil,nil,nil,nil};
		allplayershapes={nil,nil,nil,nil,nil,nil,nil,nil,nil};
		maximumplayerstochoose=8,
		numberofbeeheads=9,
		choices=9,
		choice=0,
		ybeeheads=3,
		xbeeheads=3,
		fonts={
			active=nonFonts.smallred,
			inactive=nonFonts.small,
		},
		menupoint=1,
		viewelements=view.viewgroups.beeheadselect,
		nextstages={
			_default_={
				next=function() return ncf_Stage_Menu,NON_STAGE; end,
			},
		},
	}
		
	return non_controllBeeHeadSelection(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Tutorial Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Tutorial()
	local model={
		stagename="Tutorial",
		events={
			usePad=true,
			mastermode=false,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		nextstages={
			_default_={
				next=function() return ncf_Stage_GameInit,NON_STAGE; end,
			},
		},
	}

	local view={
		NonBox.new(0,0,320,240,0),
		NonText.new(50,130,nonFonts.redblue,"Tutorial@Screen",0)
	}
	
	return non_controllWaitForInput(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- GameRound Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_GameRound()
	local model={
		stagename="gameround",
		nextstages={
			_default_={
				next=function() return ncf_Stage_Game,NON_STAGE; end,
				finish=function() return ncf_Stage_GameInit,NON_STAGE; end,
			},
		},
	}
	
	local view={
	}
	
	return non_controllGameRound(view,model);
end

-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Game Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Game()
	local model={
		stagename="Game",
		events={
			usePad=false,
			mastermode=true,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=true,
			useScreenDump=true,
		},
		nextstages={
			_default_={
				next=function() return ncf_Stage_Scoring,NON_STAGE; end,
			},
		},
	}

	local view={
		NonBox.new(0,0,320,240,0),
		NonText.new(84,110,nonFonts.small,"Press Space to quit",0)
	}
	
	-- Dummy after generation
	non_DummyResults();
	
	return non_controllWaitForInput(view,model);
end

-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Scoring Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Scoring()
	-- +++ model +++++++++++++++++++++++++++++++++++++++++++++++++
	local model={
		stagename="scoring",
		globalvalues={
			scores="nonTournamentScores",
			results="nonGameResults"
		},
		nextstages={
			_default_={
				next=function() return ncf_Stage_TournamentTable,NON_STAGE; end,
			},
		},
	};

	-- +++ view ++++++++++++++++++++++++++++++++++++++++++++++++++	
	local view={
	};

	-- +++ controller ++++++++++++++++++++++++++++++++++++++++++++
	return non_controllTournamenScoring(view,model);
end

-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- TournamentTable Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_TournamentTable()
	local model={
		stagename="TournamentTable",
		events={
			usePad=false,
			mastermode=false,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=true,
			useScreenDump=true,
		},
		globalvalues={
			scores="nonTournamentScores"
		},
		buttonpressed=nonShapes.buttonpressed,
		fonts={
			notroundresult=nonFonts.small,
			roundresult=nonFonts.smallred,
		},
		shapes={
			same=nonShapes.icons.same,
			increase=nonShapes.icons.increase,
			decrease=nonShapes.icons.decrease
		},
		showMaximumOfPlayers=false,
		showMaximumCompetitionResults=false,
		showMissingInActions=true,
		nextstages={
			_default_={
				next=function() return ncf_Stage_GameRound,NON_STAGE; end,
			},
		},
	};
	
	local view={
		sprites={
			[1]=NonSprite.new(6,56,16,18,nonShapes.buttonnotpressed,0,0),
			[2]=NonSprite.new(6,77,16,18,nonShapes.buttonnotpressed,0,0),
			[3]=NonSprite.new(6,98,16,18,nonShapes.buttonnotpressed,0,0),
			[4]=NonSprite.new(6,119,16,18,nonShapes.buttonnotpressed,0,0),
			[5]=NonSprite.new(6,140,16,18,nonShapes.buttonnotpressed,0,0),
			[6]=NonSprite.new(6,161,16,18,nonShapes.buttonnotpressed,0,0),
			[7]=NonSprite.new(6,182,16,18,nonShapes.buttonnotpressed,0,0),
			[8]=NonSprite.new(6,203,16,18,nonShapes.buttonnotpressed,0,0),
		},
		viewgroups={
			background={
				NonBox.new(0,0,320,240,0),
				NonText.new(2,28,nonFonts.redblue,"PLACE",0),
				NonText.new(90,28,nonFonts.redblue,"NAME",0),
				NonText.new(162,28,nonFonts.redblue,"RANKS",0),
				NonText.new(242,28,nonFonts.redblue,"SCORE",0)
			},
			players={
				[1]={
					playerindependent={
						place=NonText.new(27,56,model.fonts.notroundresult,"0",0),
						change=NonPicture.new(43,55,14,20,1,model.shapes.same),
						picture=NonPicture.new(62,55,20,20,0,nonInternals.nonPlayerShapes[1]),
						name=NonText.new(88,54,model.fonts.notroundresult,"00000000",0),
						last=NonText.new(229,54,model.fonts.notroundresult,"0000",0),
						points=NonText.new(264,54,model.fonts.notroundresult,"0000000",0),
					},
					playerdependent={
						[1]={
							place=NonText.new(88,65,model.fonts.notroundresult,"1",0),
							amount=NonText.new(100,65,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(94,65,model.fonts.notroundresult,":",0),
						},
						[2]={
							place=NonText.new(112,65,model.fonts.notroundresult,"2",0),
							amount=NonText.new(124,65,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(118,65,model.fonts.notroundresult,":",0),
						},
						[3]={
							place=NonText.new(136,65,model.fonts.notroundresult,"3",0),
							amount=NonText.new(148,65,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(142,65,model.fonts.notroundresult,":",0),
						},
						[4]={
							place=NonText.new(160,65,model.fonts.notroundresult,"4",0),
							amount=NonText.new(172,65,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(166,65,model.fonts.notroundresult,":",0),
						},
						[5]={
							place=NonText.new(184,65,model.fonts.notroundresult,"5",0),
							amount=NonText.new(196,65,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(190,65,model.fonts.notroundresult,":",0),
						},
						[6]={
							place=NonText.new(208,65,model.fonts.notroundresult,"6",0),
							amount=NonText.new(220,65,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(214,65,model.fonts.notroundresult,":",0),
						},
						[7]={
							place=NonText.new(232,65,model.fonts.notroundresult,"7",0),
							amount=NonText.new(244,65,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(238,65,model.fonts.notroundresult,":",0),
						},
						[8]={
							place=NonText.new(256,65,model.fonts.notroundresult,"8",0),
							amount=NonText.new(268,65,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(262,65,model.fonts.notroundresult,":",0),
						},
					},
				},
				[2]={
					playerindependent={
						place=NonText.new(27,77,model.fonts.notroundresult,"0",0),
						change=NonPicture.new(43,76,14,20,1,model.shapes.same),
						picture=NonPicture.new(62,76,20,20,0,nonInternals.nonPlayerShapes[1]),
						name=NonText.new(88,75,model.fonts.notroundresult,"00000000",0),
						last=NonText.new(229,75,model.fonts.notroundresult,"0000",0),
						points=NonText.new(264,75,model.fonts.notroundresult,"0000000",0),
					},
					playerdependent={
						[1]={
							place=NonText.new(88,86,model.fonts.notroundresult,"1",0),
							amount=NonText.new(100,86,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(94,86,model.fonts.notroundresult,":",0),
						},
						[2]={
							place=NonText.new(112,86,model.fonts.notroundresult,"2",0),
							amount=NonText.new(124,86,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(118,86,model.fonts.notroundresult,":",0),
						},
						[3]={
							place=NonText.new(136,86,model.fonts.notroundresult,"3",0),
							amount=NonText.new(148,86,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(142,86,model.fonts.notroundresult,":",0),
						},
						[4]={
							place=NonText.new(160,86,model.fonts.notroundresult,"4",0),
							amount=NonText.new(172,86,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(166,86,model.fonts.notroundresult,":",0),
						},
						[5]={
							place=NonText.new(184,86,model.fonts.notroundresult,"5",0),
							amount=NonText.new(196,86,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(190,86,model.fonts.notroundresult,":",0),
						},
						[6]={
							place=NonText.new(208,86,model.fonts.notroundresult,"6",0),
							amount=NonText.new(220,86,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(214,86,model.fonts.notroundresult,":",0),
						},
						[7]={
							place=NonText.new(232,86,model.fonts.notroundresult,"7",0),
							amount=NonText.new(244,86,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(238,86,model.fonts.notroundresult,":",0),
						},
						[8]={
							place=NonText.new(256,86,model.fonts.notroundresult,"8",0),
							amount=NonText.new(268,86,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(262,86,model.fonts.notroundresult,":",0),
						},
					},
				},
				[3]={
					playerindependent={
						place=NonText.new(27,98,model.fonts.notroundresult,"0",0),
						change=NonPicture.new(43,97,14,20,1,model.shapes.same),
						picture=NonPicture.new(62,97,20,20,0,nonInternals.nonPlayerShapes[1]),
						name=NonText.new(88,96,model.fonts.notroundresult,"00000000",0),
						last=NonText.new(229,96,model.fonts.notroundresult,"0000",0),
						points=NonText.new(264,96,model.fonts.notroundresult,"0000000",0),
					},
					playerdependent={
						[1]={
							place=NonText.new(88,107,model.fonts.notroundresult,"1",0),
							amount=NonText.new(100,107,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(94,107,model.fonts.notroundresult,":",0),
						},
						[2]={
							place=NonText.new(112,107,model.fonts.notroundresult,"2",0),
							amount=NonText.new(124,107,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(118,107,model.fonts.notroundresult,":",0),
						},
						[3]={
							place=NonText.new(136,107,model.fonts.notroundresult,"3",0),
							amount=NonText.new(148,107,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(142,107,model.fonts.notroundresult,":",0),
						},
						[4]={
							place=NonText.new(160,107,model.fonts.notroundresult,"4",0),
							amount=NonText.new(172,107,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(166,107,model.fonts.notroundresult,":",0),
						},
						[5]={
							place=NonText.new(184,107,model.fonts.notroundresult,"5",0),
							amount=NonText.new(196,107,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(190,107,model.fonts.notroundresult,":",0),
						},
						[6]={
							place=NonText.new(208,107,model.fonts.notroundresult,"6",0),
							amount=NonText.new(220,107,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(214,107,model.fonts.notroundresult,":",0),
						},
						[7]={
							place=NonText.new(232,107,model.fonts.notroundresult,"7",0),
							amount=NonText.new(244,107,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(238,107,model.fonts.notroundresult,":",0),
						},
						[8]={
							place=NonText.new(256,107,model.fonts.notroundresult,"8",0),
							amount=NonText.new(268,107,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(262,107,model.fonts.notroundresult,":",0),
						},
					},
				},
				[4]={
					playerindependent={
						place=NonText.new(27,119,model.fonts.notroundresult,"0",0),
						change=NonPicture.new(43,118,14,20,1,model.shapes.same),
						picture=NonPicture.new(62,118,20,20,0,nonInternals.nonPlayerShapes[1]),
						name=NonText.new(88,117,model.fonts.notroundresult,"00000000",0),
						last=NonText.new(229,117,model.fonts.notroundresult,"0000",0),
						points=NonText.new(264,117,model.fonts.notroundresult,"0000000",0),
					},
					playerdependent={
						[1]={
							place=NonText.new(88,128,model.fonts.notroundresult,"1",0),
							amount=NonText.new(100,128,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(94,128,model.fonts.notroundresult,":",0),
						},
						[2]={
							place=NonText.new(112,128,model.fonts.notroundresult,"2",0),
							amount=NonText.new(124,128,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(118,128,model.fonts.notroundresult,":",0),
						},
						[3]={
							place=NonText.new(136,128,model.fonts.notroundresult,"3",0),
							amount=NonText.new(148,128,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(142,128,model.fonts.notroundresult,":",0),
						},
						[4]={
							place=NonText.new(160,128,model.fonts.notroundresult,"4",0),
							amount=NonText.new(172,128,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(166,128,model.fonts.notroundresult,":",0),
						},
						[5]={
							place=NonText.new(184,128,model.fonts.notroundresult,"5",0),
							amount=NonText.new(196,128,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(190,128,model.fonts.notroundresult,":",0),
						},
						[6]={
							place=NonText.new(208,128,model.fonts.notroundresult,"6",0),
							amount=NonText.new(220,128,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(214,128,model.fonts.notroundresult,":",0),
						},
						[7]={
							place=NonText.new(232,128,model.fonts.notroundresult,"7",0),
							amount=NonText.new(244,128,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(238,128,model.fonts.notroundresult,":",0),
						},
						[8]={
							place=NonText.new(256,128,model.fonts.notroundresult,"8",0),
							amount=NonText.new(268,128,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(262,128,model.fonts.notroundresult,":",0),
						},
					},
				},
				[5]={
					playerindependent={
						place=NonText.new(27,140,model.fonts.notroundresult,"0",0),
						change=NonPicture.new(43,139,14,20,1,model.shapes.same),
						picture=NonPicture.new(62,139,20,20,0,nonInternals.nonPlayerShapes[1]),
						name=NonText.new(88,138,model.fonts.notroundresult,"00000000",0),
						last=NonText.new(229,138,model.fonts.notroundresult,"0000",0),
						points=NonText.new(264,138,model.fonts.notroundresult,"0000000",0),
					},
					playerdependent={
						[1]={
							place=NonText.new(88,149,model.fonts.notroundresult,"1",0),
							amount=NonText.new(100,149,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(94,149,model.fonts.notroundresult,":",0),
						},
						[2]={
							place=NonText.new(112,149,model.fonts.notroundresult,"2",0),
							amount=NonText.new(124,149,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(118,149,model.fonts.notroundresult,":",0),
						},
						[3]={
							place=NonText.new(136,149,model.fonts.notroundresult,"3",0),
							amount=NonText.new(148,149,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(142,149,model.fonts.notroundresult,":",0),
						},
						[4]={
							place=NonText.new(160,149,model.fonts.notroundresult,"4",0),
							amount=NonText.new(172,149,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(166,149,model.fonts.notroundresult,":",0),
						},
						[5]={
							place=NonText.new(184,149,model.fonts.notroundresult,"5",0),
							amount=NonText.new(196,149,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(190,149,model.fonts.notroundresult,":",0),
						},
						[6]={
							place=NonText.new(208,149,model.fonts.notroundresult,"6",0),
							amount=NonText.new(220,149,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(214,149,model.fonts.notroundresult,":",0),
						},
						[7]={
							place=NonText.new(232,149,model.fonts.notroundresult,"7",0),
							amount=NonText.new(244,149,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(238,149,model.fonts.notroundresult,":",0),
						},
						[8]={
							place=NonText.new(256,149,model.fonts.notroundresult,"8",0),
							amount=NonText.new(268,149,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(262,149,model.fonts.notroundresult,":",0),
						},
					},
				},
				[6]={
					playerindependent={
						place=NonText.new(27,161,model.fonts.notroundresult,"0",0),
						change=NonPicture.new(43,160,14,20,1,model.shapes.same),
						picture=NonPicture.new(62,160,20,20,0,nonInternals.nonPlayerShapes[1]),
						name=NonText.new(88,159,model.fonts.notroundresult,"00000000",0),
						last=NonText.new(229,159,model.fonts.notroundresult,"0000",0),
						points=NonText.new(264,159,model.fonts.notroundresult,"0000000",0),
					},
					playerdependent={
						[1]={
							place=NonText.new(88,170,model.fonts.notroundresult,"1",0),
							amount=NonText.new(100,170,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(94,170,model.fonts.notroundresult,":",0),
						},
						[2]={
							place=NonText.new(112,170,model.fonts.notroundresult,"2",0),
							amount=NonText.new(124,170,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(118,170,model.fonts.notroundresult,":",0),
						},
						[3]={
							place=NonText.new(136,170,model.fonts.notroundresult,"3",0),
							amount=NonText.new(148,170,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(142,170,model.fonts.notroundresult,":",0),
						},
						[4]={
							place=NonText.new(160,170,model.fonts.notroundresult,"4",0),
							amount=NonText.new(172,170,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(166,170,model.fonts.notroundresult,":",0),
						},
						[5]={
							place=NonText.new(184,170,model.fonts.notroundresult,"5",0),
							amount=NonText.new(196,170,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(190,170,model.fonts.notroundresult,":",0),
						},
						[6]={
							place=NonText.new(208,170,model.fonts.notroundresult,"6",0),
							amount=NonText.new(220,170,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(214,170,model.fonts.notroundresult,":",0),
						},
						[7]={
							place=NonText.new(232,170,model.fonts.notroundresult,"7",0),
							amount=NonText.new(244,170,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(238,170,model.fonts.notroundresult,":",0),
						},
						[8]={
							place=NonText.new(256,170,model.fonts.notroundresult,"8",0),
							amount=NonText.new(268,170,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(262,170,model.fonts.notroundresult,":",0),
						},
					},
				},
				[7]={
					playerindependent={
						place=NonText.new(27,182,model.fonts.notroundresult,"0",0),
						change=NonPicture.new(43,181,14,20,1,model.shapes.same),
						picture=NonPicture.new(62,181,20,20,0,nonInternals.nonPlayerShapes[1]),
						name=NonText.new(88,180,model.fonts.notroundresult,"00000000",0),
						last=NonText.new(229,180,model.fonts.notroundresult,"0000",0),
						points=NonText.new(264,180,model.fonts.notroundresult,"0000000",0),
					},
					playerdependent={
						[1]={
							place=NonText.new(88,191,model.fonts.notroundresult,"1",0),
							amount=NonText.new(100,191,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(94,191,model.fonts.notroundresult,":",0),
						},
						[2]={
							place=NonText.new(112,191,model.fonts.notroundresult,"2",0),
							amount=NonText.new(124,191,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(118,191,model.fonts.notroundresult,":",0),
						},
						[3]={
							place=NonText.new(136,191,model.fonts.notroundresult,"3",0),
							amount=NonText.new(148,191,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(142,191,model.fonts.notroundresult,":",0),
						},
						[4]={
							place=NonText.new(160,191,model.fonts.notroundresult,"4",0),
							amount=NonText.new(172,191,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(166,191,model.fonts.notroundresult,":",0),
						},
						[5]={
							place=NonText.new(184,191,model.fonts.notroundresult,"5",0),
							amount=NonText.new(196,191,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(190,191,model.fonts.notroundresult,":",0),
						},
						[6]={
							place=NonText.new(208,191,model.fonts.notroundresult,"6",0),
							amount=NonText.new(220,191,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(214,191,model.fonts.notroundresult,":",0),
						},
						[7]={
							place=NonText.new(232,191,model.fonts.notroundresult,"7",0),
							amount=NonText.new(244,191,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(238,191,model.fonts.notroundresult,":",0),
						},
						[8]={
							place=NonText.new(256,191,model.fonts.notroundresult,"8",0),
							amount=NonText.new(268,191,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(262,191,model.fonts.notroundresult,":",0),
						},
					},
				},
				[8]={
					playerindependent={
						place=NonText.new(27,203,model.fonts.notroundresult,"0",0),
						change=NonPicture.new(43,202,14,20,1,model.shapes.same),
						picture=NonPicture.new(62,202,20,20,0,nonInternals.nonPlayerShapes[1]),
						name=NonText.new(88,201,model.fonts.notroundresult,"00000000",0),
						last=NonText.new(229,201,model.fonts.notroundresult,"0000",0),
						points=NonText.new(264,201,model.fonts.notroundresult,"0000000",0),
					},
					playerdependent={
						[1]={
							place=NonText.new(88,212,model.fonts.notroundresult,"1",0),
							amount=NonText.new(100,212,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(94,212,model.fonts.notroundresult,":",0),
						},
						[2]={
							place=NonText.new(112,212,model.fonts.notroundresult,"2",0),
							amount=NonText.new(124,212,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(118,212,model.fonts.notroundresult,":",0),
						},
						[3]={
							place=NonText.new(136,212,model.fonts.notroundresult,"3",0),
							amount=NonText.new(148,212,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(142,212,model.fonts.notroundresult,":",0),
						},
						[4]={
							place=NonText.new(160,212,model.fonts.notroundresult,"4",0),
							amount=NonText.new(172,212,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(166,212,model.fonts.notroundresult,":",0),
						},
						[5]={
							place=NonText.new(184,212,model.fonts.notroundresult,"5",0),
							amount=NonText.new(196,212,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(190,212,model.fonts.notroundresult,":",0),
						},
						[6]={
							place=NonText.new(208,212,model.fonts.notroundresult,"6",0),
							amount=NonText.new(220,212,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(214,212,model.fonts.notroundresult,":",0),
						},
						[7]={
							place=NonText.new(232,212,model.fonts.notroundresult,"7",0),
							amount=NonText.new(244,212,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(238,212,model.fonts.notroundresult,":",0),
						},
						[8]={
							place=NonText.new(256,212,model.fonts.notroundresult,"8",0),
							amount=NonText.new(268,212,model.fonts.notroundresult,"00",0),
							doublepoint=NonText.new(262,212,model.fonts.notroundresult,":",0),
						},
					},
				},
			},
			mia={
				[1]={
					[1]=NonPicture.new(12,86,296,16,0,nonShapes.mia[1]),
					[2]=NonText.new(100,90,nonFonts.small,"Missing in Action",0),
				},
				[2]={
					[1]=NonPicture.new(12,107,296,16,0,nonShapes.mia[2]),
					[2]=NonText.new(100,111,nonFonts.small,"Missing in Action",0),
				},
				[3]={
					[1]=NonPicture.new(12,128,296,16,0,nonShapes.mia[3]),
					[2]=NonText.new(100,132,nonFonts.small,"Missing in Action",0),
				},
				[4]={
					[1]=NonPicture.new(12,149,296,16,0,nonShapes.mia[4]),
					[2]=NonText.new(100,153,nonFonts.small,"Missing in Action",0),
				},
				[5]={
					[1]=NonPicture.new(12,170,296,16,0,nonShapes.mia[5]),
					[2]=NonText.new(100,174,nonFonts.small,"Missing in Action",0),
				},
				[6]={
					[1]=NonPicture.new(12,191,296,16,0,nonShapes.mia[6]),
					[2]=NonText.new(100,195,nonFonts.small,"Missing in Action",0),
				},
				[7]={
					[1]=NonPicture.new(12,212,296,16,0,nonShapes.mia[7]),
					[2]=NonText.new(100,216,nonFonts.small,"Missing in Action",0),
				},
			},
		},
		"background",
		"players",
		"mia",
	};

	return non_controllShowTournamentScores(view,model);
end

-- **************************************************
-- main loop
-- **************************************************

non_Dispatcher();

print("thanks for using NonConForm, good bye");