-- ****************************************************
-- showGame
-- ****************************************************
function showGame(model,view)
	-- *** Variables ************************************
	local counter=0;
	local pads={-1,-1,-1,-1,-1,-1,-1,-1};

	-- +++ Collision initialization ++++++++++++++++++
	nonsys:clearCollision();

	-- +++ paint view ++++++++++++++++++++++++++++++++
	non_paintView(view);		

	-- +++ create sprites ++++++++++++++++++++++++++++
	for playercounter=1,nonGlobals.nonNumberOfPlayers do
			nonInternals.nonSprites[playercounter]=NonSprite.new(model.startpositions.x[playercounter],model.startpositions.y[playercounter],4,4,nonShapes.playersprites[playercounter],0,playercounter);
	end

	-- +++++++++++++++++++++++++++++++++++++++++++++++
	-- Main game loop
	-- +++++++++++++++++++++++++++++++++++++++++++++++
	while nonInternals.nonExitEvent==NON_NOTHING do
		non_prePaint();

		non_refreshControlls();

		-- +++ move sprites because of controllers +++++
		for counter=1,nonGlobals.nonNumberOfPlayers do
			if model.playergameover[counter]==0 then
				-- +++ get controllsers ++++++++++++++++++++
				pads[counter]=nonInternals.nonControllers:getPacket(counter);
				-- +++ react on controllers ++++++++++++++++
				model.controlls.playerdirection[counter]=model.controlls.controller(model,pads[counter],model.controlls.playerdirection[counter],nonInternals.nonSprites[counter]);
			end 
		end
		
		non_controllsEvents(model);

		non_postPaint();
	end
	
	-- *** Finish *********************************************
	non_clearSprites();

	-- *** Cleanup ********************************************
	collectgarbage();
end