dofile("..\\lib\\non_base.lua");
dofile("..\\lib\\non_util.lua");
dofile("..\\lib\\non_vdeo.lua");
dofile("..\\lib\\non_pain.lua");
dofile("..\\lib\\non_cont.lua");
dofile("..\\lib\\non_ctl.lua");
dofile("..\\lib\\non_bHea.lua");
dofile("..\\lib\\non_f030.lua");

dofile("..\\noncon\\multimed.lua");

dofile("..\\noncon\\ncfgame.lua");

-- ***************************************************
-- Constants
-- ***************************************************

NON_MAXIMUMPLAYERS=8;
NON_MINIMUMPLAYERS=1;

ncf_Stage_exit="exit";

-- **************************************************
-- Init Stage
-- **************************************************
function ncf_Stage_Init()
	local model={
		stagename="Init",
		screenwidth=320,
		screenheight=240,
		useKeyBoard=true,
		useTeamTaps=false,
		useJagPads=true,
		highscorefilenameparts={"nonDifficulty"},
		beehead={
			useBeeHead=true,
			searchinfolders={"c:","d:","e:","f:","g:","h:","i:","j:","/user/local"},
			defaultplayershapewidth=20,
			defaultplayershapeheight=20,
		},
		nextstages={
			_default_={
				next=function() return ncf_Stage_Logo,NON_STAGE; end
			}
		}
	}
	
	local view={
	}

	return non_controllInit(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Logo Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Logo()
	local model={
		stagename="Logo",
		events={
			usePad=true,
			mastermode=false,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		nextstages={
			_default_={
				next=function() return ncf_Stage_Title,NON_STAGE; end,
			},
		},
	}

	local view={
		NonBox.new(0,0,320,240,0),
		NonText.new(50,130,nonFonts.redblue,"Logo@Screen",0)
	}
	
	return non_controllWaitForInput(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Title Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Title()
	local model={
		stagename="Title",
		events={
			usePad=true,
			mastermode=false,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		nextstages={
			_default_={
				next=function() return ncf_Stage_Credits,NON_STAGE; end,
			},
		},
	}

	local view={
		NonBox.new(0,0,320,240,0),
		NonText.new(50,130,nonFonts.redblue,"Title@Screen",0)
	}
	
	return non_controllWaitForInput(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Credits Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Credits()
	local model={
		stagename="Credits",
		events={
			usePad=true,
			mastermode=false,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		nextstages={
			Title={
				next=function() return ncf_Stage_GameInit,NON_STAGE; end,
			},
			Menu={
				next=function() return ncf_Stage_Menu,NON_STAGE; end,
			},
		},
	}

	local view={
		NonBox.new(0,0,320,240,0),
		NonText.new(50,130,nonFonts.redblue,"Credits@Screen",0)
	}
	
	return non_controllWaitForInput(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- GameInit Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_GameInit()
	local model={
		stagename="GameInit",
		nextstages={
			_default_={
				next=function() return ncf_Stage_Menu,NON_STAGE; end,
			},
		},
	}

	local view={
	}
	
	return non_controllGameInit(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Menu Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Menu()
	local view={
		viewgroups={
			menu={
				options={
					NonText.new(50,36,nonFonts.white,"TUTORIAL",0),
					NonText.new(50,63,nonFonts.white,"OPTIONS",0),
					NonText.new(50,90,nonFonts.white,"PLAYERS",0),
					NonText.new(50,117,nonFonts.white,"CREDITS",0),
					NonText.new(50,144,nonFonts.white,"START",0),
					NonText.new(50,171,nonFonts.white,"EXIT",0),
				},
			}
		},
		NonBox.new(0,0,320,240,0),
		"menu"
	}
	
	local model={
		stagename="Menu",
		events={
			usePad=false,
			mastermode=true,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		choices=6,
		choice=0,
		fonts={
			active=nonFonts.red,
			inactive=nonFonts.white
		},
		menupoint=1,
		nextstages={
			_default_={
				function() return ncf_Stage_Tutorial,NON_STAGE; end,
				function() return ncf_Stage_Options,NON_STAGE; end,
				function() return ncf_Stage_Players,NON_STAGE; end,
				function() return ncf_Stage_Credits,NON_STAGE; end,
				function() return ncf_Stage_GameRound,NON_STAGE; end,
				function() return "exit"; end,
			},
		},
		viewelements=view.viewgroups.menu
	}
	
	return non_controllMenu(view,model);
end

-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Options Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Options()
	local model={
		stagename="Options",
		events={
			usePad=true,
			mastermode=true,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		globalvalues={
			"nonDifficulty",
		},
		texts={
			"Difficulty",
		},
		pictures={
			nonShapes.icons.rounds
		},
		min={1},
		max={8},
		checkpictures={
			nonShapes.icons.no,
			nonShapes.icons.yes
		},
		choices=1,
		choice=0,
		menupoint=1,
		fonts={
			active=nonFonts.red,
			inactive=nonFonts.white
		},
		nextstages={
			_default_={
				next=function() return ncf_Stage_Menu,NON_STAGE; end,
			},
		},
	}
	
	local view={
		viewgroups={
			background={
				NonBox.new(0,0,320,240,0),
			},
			options={
				NonText.new(50,36,nonFonts.red,"",0),
			},
			valuecomponents={
				NonText.new(266,36,nonFonts.white,"",0),
			},
			picturecomponents={
				NonPicture.new(10,36,36,25,0,nonShapes.icons.no),
			},
		},
		"background",
		"options",
		"valuecomponents",
		"picturecomponents"
	}
	
	return non_controllOption(view,model);
end

-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Players Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Players()
	local view={
		viewgroups={
			background={
				NonBox.new(0,0,320,240,0),
				NonText.new(100,10,nonFonts.redblue,"Players",0),
				NonText.new(91,92,nonFonts.redblue,"beeheads",0),
				NonText.new(20,200,nonFonts.small,"press pad key 1-8 to select players",0),
				NonText.new(56,210,nonFonts.small,"press pad button b to exit",0),
			},
			playersselect={
				numbers={
					[1]=NonText.new(46,36,nonFonts.small,"1",0),
					[2]=NonText.new(76,36,nonFonts.small,"2",0),
					[3]=NonText.new(106,36,nonFonts.small,"3",0),
					[4]=NonText.new(136,36,nonFonts.small,"4",0),
					[5]=NonText.new(166,36,nonFonts.small,"5",0),
					[6]=NonText.new(196,36,nonFonts.small,"6",0),
					[7]=NonText.new(226,36,nonFonts.small,"7",0),
					[8]=NonText.new(256,36,nonFonts.small,"8",0),
				},
				optionpictures={
					[1]=NonPicture.new(40,50,20,20,0,nonInternals.nonPlayerShapes[1]),
					[2]=NonPicture.new(70,50,20,20,0,nonInternals.nonPlayerShapes[2]),
					[3]=NonPicture.new(100,50,20,20,0,nonInternals.nonPlayerShapes[3]),
					[4]=NonPicture.new(130,50,20,20,0,nonInternals.nonPlayerShapes[4]),
					[5]=NonPicture.new(160,50,20,20,0,nonInternals.nonPlayerShapes[5]),
					[6]=NonPicture.new(190,50,20,20,0,nonInternals.nonPlayerShapes[6]),
					[7]=NonPicture.new(220,50,20,20,0,nonInternals.nonPlayerShapes[7]),
					[8]=NonPicture.new(250,50,20,20,0,nonInternals.nonPlayerShapes[8])
				},
				options={
					[1]=NonText.new(39,76,nonFonts.small,"123",0),
					[2]=NonText.new(69,76,nonFonts.small,"123",0),
					[3]=NonText.new(99,76,nonFonts.small,"123",0),
					[4]=NonText.new(129,76,nonFonts.small,"123",0),
					[5]=NonText.new(159,76,nonFonts.small,"123",0),
					[6]=NonText.new(189,76,nonFonts.small,"123",0),
					[7]=NonText.new(219,76,nonFonts.small,"123",0),
					[8]=NonText.new(249,76,nonFonts.small,"123",0)
				}
			},
			beeheadselect={
				optionpictures={
					NonPicture.new(16,118,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(116,118,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(216,118,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(16,144,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(116,144,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(216,144,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(16,170,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(116,170,20,20,0,nonInternals.nonPlayerShapes[1]),
					NonPicture.new(216,170,20,20,0,nonInternals.nonPlayerShapes[1])
				},
				options={
					NonText.new(46,124,nonFonts.small,"12345678",0),
					NonText.new(146,124,nonFonts.small,"12345678",0),
					NonText.new(246,124,nonFonts.small,"12345678",0),
					NonText.new(46,150,nonFonts.small,"12345678",0),
					NonText.new(146,150,nonFonts.small,"12345678",0),
					NonText.new(246,150,nonFonts.small,"12345678",0),
					NonText.new(46,176,nonFonts.small,"12345678",0),
					NonText.new(146,176,nonFonts.small,"12345678",0),
					NonText.new(246,176,nonFonts.small,"12345678",0)
				},
			},
		},
		"background",
		"playersselect",
		"beeheadselect"		
	}

	local model={
		stagename="Players",
		globalvalues={
			topbeeheadplayerid="nonTopBeeHeadPlayerID"
		},
		events={
			usePad=true,
			mastermode=true,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		center=true,
		topplayerid=17,
		allplayerpics={nil,nil,nil,nil,nil,nil,nil,nil,nil};
		allplayershapes={nil,nil,nil,nil,nil,nil,nil,nil,nil};
		maximumplayerstochoose=8,
		numberofbeeheads=9,
		choices=9,
		choice=0,
		ybeeheads=3,
		xbeeheads=3,
		fonts={
			active=nonFonts.smallred,
			inactive=nonFonts.small,
		},
		menupoint=1,
		viewelements=view.viewgroups.beeheadselect,
		nextstages={
			_default_={
				next=function() return ncf_Stage_Menu,NON_STAGE; end,
			},
		},
	}
		
	return non_controllBeeHeadSelection(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Tutorial Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Tutorial()
	local model={
		stagename="Tutorial",
		events={
			usePad=true,
			mastermode=false,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=false,
			useScreenDump=true,
		},
		nextstages={
			_default_={
				next=function() return ncf_Stage_GameInit,NON_STAGE; end,
			},
		},
	}

	local view={
		NonBox.new(0,0,320,240,0),
		NonText.new(50,130,nonFonts.redblue,"Tutorial@Screen",0)
	}
	
	return non_controllWaitForInput(view,model);
end
-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- GameRound Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_GameRound()
	local model={
		stagename="gameround",
		nextstages={
			_default_={
				next=function() return ncf_Stage_Game,NON_STAGE; end,
				finish=function() return ncf_Stage_GameInit,NON_STAGE; end,
			},
		},
	}
	
	local view={
	}
	
	return non_controllGameRound(view,model);
end

-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Game Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Game()
	local model={
		stagename="Game",
		events={
			usePad=false,
			mastermode=true,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=true,
			useScreenDump=true,
		},
		nextstages={
			_default_={
				next=function() return ncf_Stage_Scoring,NON_STAGE; end,
			},
		},
	}

	local view={
		NonBox.new(0,0,320,240,0),
		NonText.new(84,110,nonFonts.small,"Press Space to quit",0)
	}
	
	-- Dummy after generation
	non_DummyResult(50,50);
	
	return non_controllWaitForInput(view,model);
end

-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- Scoring Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_Scoring()
	-- +++ model +++++++++++++++++++++++++++++++++++++++++++++++++
	local model={
		stagename="scoring",
		globalvalues={
			scores="nonSingleScores",
			results="nonGameResults"
		},
		numberofscores=100,
		nextstages={
			_default_={
				next=function() return ncf_Stage_HighscoreTable,NON_STAGE; end,
			},
		},
	};

	-- +++ view ++++++++++++++++++++++++++++++++++++++++++++++++++	
	local view={
	};

	-- +++ controller ++++++++++++++++++++++++++++++++++++++++++++
	return non_controllSingleScoring(view,model);
end

-- +++++++++++++++++++++++++++++++++++++++++++++++++++
-- HighscoreTable Stage
-- +++++++++++++++++++++++++++++++++++++++++++++++++++ 
function ncf_Stage_HighscoreTable()
	local model={
		stagename="HighscoreTable",
		events={
			usePad=true,
			mastermode=true,
			useKeyBoard=true,
			useInitEvent=true,
			useMenuEvent=true,
			useScreenDump=true,
		},
		globalvalues={
			scores="nonSingleScores"
		},
		input={
			useJagPad=true,
			useKeyBoard=true,
		},
		fonts={
			old=nonFonts.small,
			new=nonFonts.smallred,
		},
		placecounter=1,
		numberofdisplayedscores=8,
		numberofscores=100,
		nextstages={
			_default_={
				next=function() return ncf_Stage_GameRound,NON_STAGE; end,
			},
		},
	};
	
	local view={
		viewgroups={
			background={
				NonBox.new(0,0,320,240,0),
				NonText.new(38,8,nonFonts.redblue,"PLACE",0),
				NonText.new(126,8,nonFonts.redblue,"NAME",0),
				NonText.new(198,8,nonFonts.redblue,"SCORE",0),
				NonText.new(32,210,nonFonts.small,"scroll the list with up and down",0),
				NonText.new(68,220,nonFonts.small,"press button b to exit",0),
			},
			scores={
				[1]={
					place=NonText.new(72,36,model.fonts.old,"0",0),
					picture=NonPicture.new(96,30,20,20,0,nonInternals.nonPlayerShapes[1]),
					name=NonText.new(121,36,model.fonts.old,"noname",0),
					points=NonText.new(233,36,model.fonts.old,"0",0)
				},
				[2]={
					place=NonText.new(72,57,model.fonts.old,"0",0),
					picture=NonPicture.new(96,51,20,20,0,nonInternals.nonPlayerShapes[1]),
					name=NonText.new(121,57,model.fonts.old,"noname",0),
					points=NonText.new(233,57,model.fonts.old,"0",0)
				},
				[3]={
					place=NonText.new(72,78,model.fonts.old,"0",0),
					picture=NonPicture.new(96,72,20,20,0,nonInternals.nonPlayerShapes[1]),
					name=NonText.new(121,78,model.fonts.old,"noname",0),
					points=NonText.new(233,78,model.fonts.old,"0",0)
				},
				[4]={
					place=NonText.new(72,99,model.fonts.old,"0",0),
					picture=NonPicture.new(96,93,20,20,0,nonInternals.nonPlayerShapes[1]),
					name=NonText.new(121,99,model.fonts.old,"noname",0),
					points=NonText.new(233,99,model.fonts.old,"0",0)
				},
				[5]={
					place=NonText.new(72,120,model.fonts.old,"0",0),
					picture=NonPicture.new(96,114,20,20,0,nonInternals.nonPlayerShapes[1]),
					name=NonText.new(121,120,model.fonts.old,"noname",0),
					points=NonText.new(233,120,model.fonts.old,"0",0)
				},
				[6]={
					place=NonText.new(72,141,model.fonts.old,"0",0),
					picture=NonPicture.new(96,135,20,20,0,nonInternals.nonPlayerShapes[1]),
					name=NonText.new(121,141,model.fonts.old,"noname",0),
					points=NonText.new(233,141,model.fonts.old,"0",0)
				},
				[7]={
					place=NonText.new(72,162,model.fonts.old,"0",0),
					picture=NonPicture.new(96,156,20,20,0,nonInternals.nonPlayerShapes[1]),
					name=NonText.new(121,162,model.fonts.old,"noname",0),
					points=NonText.new(233,162,model.fonts.old,"0",0)
				},
				[8]={
					place=NonText.new(72,183,model.fonts.old,"0",0),
					picture=NonPicture.new(96,177,20,20,0,nonInternals.nonPlayerShapes[1]),
					name=NonText.new(121,183,model.fonts.old,"noname",0),
					points=NonText.new(233,183,model.fonts.old,"0",0)
				},
			},
		},
		"background",
		"scores"
	};

	return non_controllShowSingleScores(view,model);
end

-- **************************************************
-- main loop
-- **************************************************

non_Dispatcher();

print("thanks for using NonConForm, good bye");